<?php
namespace PME\Controllers\Servico;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class PadraoDeServicoController {
	protected $connection;

  public function __construct($connection) {
    $this->connection = $connection;
	}
	
	public function updateAtualizacaoAutomatica(DTO\Request $request, DTO\Response $response){
		try{
			$parameters = $request->getParameters();
      $servicos = $parameters['padroesServicosSelecionados'];
      $unidades = $parameters['unidadesSelecionadasForm'];
      $cdfilial = ' ';
      
      if(sizeof($unidades) == 0) 
    		$cdfilial = 'T'; 
			else
    		$cdfilial = join("_", $unidades);
      
      $this->connection->beginTransaction();
      
      $query = "UPDATE SERVICO SET NMSERVICO = :NMSERVICO, CDPRODUTO = :CDPRODUTO WHERE (INSTR(:CDFILIAL, CDFILIAL) <> 0 OR :CDFILIAL = 'T') AND CDSERVFILI = :CDSERVFILI";
      
  		foreach($servicos as $servico){
  				$params = array(
  					'NMSERVICO' 	=> $servico['NMSERVPADR'],
  					'CDPRODUTO'   => $servico['CDPRODUTO'],
  					'CDFILIAL'  	=> $cdfilial,
  					'CDSERVFILI'  => $servico['CDSERVPADR'],
  				);
          $this->connection->prepare($query)->execute($params);
		  }
			$this->connection->commit();
      $response->addDataSet(new DataSet("success", array(true)));
		} catch(\Exception $e){
			$this->connection->rollback();
		  $response->setError(new Error($e->getMessage(), 500));
		}
	}
	
}