<?php
namespace PME\Modules\Planejamento\Prato;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;


class QtdPessoaController extends \PME\Services\TeknisaCrud {
	
	protected $crudService;
	protected $parameterBag;
  protected $Lista;
  protected $utilities;

  public function __construct($crudService, $parameterBag, $entityManager, $Lista, $utilities) {
    $this->entityManager = $entityManager;
    $this->Lista = $Lista;
    $this->utilities = $utilities;
    parent::__construct($crudService, $parameterBag);
  }
  
  public function procedureQtdPessoa(DTO\Request $request, DTO\Response $response){
    $nrorg = $this->utilities->getNrOrg();
    $rows = $request->getRow();
    
    $cdprodIni = $rows['PRATO_INICIAL'] ? $rows['PRATO_INICIAL'] : 0;
    $cdprodFin = $rows['PRATO_FINAL'] ? $rows['PRATO_FINAL'].'z' : 'zzzzzzzzzz';
    
    $rowsReceita = $rows['IDTIPORECEITA'];
    
    $tipoReceita = 'PLST';    
    if (!(in_array('P', $rowsReceita))) $tipoReceita = substr_replace($tipoReceita, 'X', 0, 1);
    if (!(in_array('L', $rowsReceita))) $tipoReceita = substr_replace($tipoReceita, 'X', 1, 1);
    if (!(in_array('S', $rowsReceita))) $tipoReceita = substr_replace($tipoReceita, 'X', 2, 1);
    if (!(in_array('T', $rowsReceita))) $tipoReceita = substr_replace($tipoReceita, 'X', 3, 1);

    $nrlista = '';
    $nrlistatp = '';
    $a = false;
    
    // foreach($rowsReceita as $row) {
      if (in_array('S', $rowsReceita)) {
        if(count($rows['SERVICO']) > 0) { 
          $servico = $rows['SERVICO'];
          } else {
          $servico = $this->getServicos($rows);
        }
        
        $unidadeServico = '';
        foreach($servico as $servfili) {
          $unidadeServico .= $servfili['FILISERV'] . "_";
        }
        
        $nrlista = $this->Lista->geraLista($unidadeServico, $nrorg);
      }
      else {
        $nrlista = '';
        
        if (in_array('L', $rowsReceita)) {
          if(count($rows['UNIDADE']) > 0) { 
            $unidade = $rows['UNIDADE'];
            $unidadeConcat = '';
            foreach($unidade as $fil) {
              $unidadeConcat .= $fil . "_";
            }
          } else {
            $unidade = $this->getServicos($rows);
          
            $unidadeConcat = '';
            foreach($unidade as $fil) {
              $unidadeConcat .= $fil['CDFILIAL'] . "_";
            }
          }
          
          $nrlista = $this->Lista->geraLista($unidadeConcat, $nrorg);
        }

        if (in_array('T', $rowsReceita) and !$nrlista) {
          if(count($rows['UNIDADE']) > 0) {
            $unidade = array();
            foreach ($rows['UNIDADE'] as $cd) {
              $unidade[] = array("CDFILIAL" => $cd);
            }
          } else {
            $unidade = $this->getAgregadaCentralPAE($rows);      
          }
          
          $unidadeConcat = '';
          foreach($unidade as $filiTp) {
            $unidadeConcat .= $filiTp['CDFILIAL'] . "_";
          }
        
          $nrlista = $this->Lista->geraLista($unidadeConcat, $nrorg);
        }
      }
      
      if (in_array('T', $rowsReceita)) $a = true;
    //}

    if ($a) {
      $tpCard = '';
      if(count($rows['TPCARD']) > 0) { 
        $tpCard = $rows['TPCARD']; 
      } else {
        $tpCard = $this->getTipoCard($rows); 
      }
      
      $tpCardConcat = '';
      foreach($tpCard as $row) {
        $tpCardConcat .= $row['CDTIPOCARD'] . "_";
      }
      $nrlistatp = $this->Lista->geraLista($tpCardConcat, $nrorg); 
    }

    $rowsRadio = $rows['ORDENA'];
    if ($rowsRadio === "1") $vrqtdepessoa = null;
    if ($rowsRadio === "0") $vrqtdepessoa = $rows['VRQTDEPESSOA'];

    $connection = $this->entityManager->getConnection();
    $procedureCons = new StoredProcedure($connection, 'CALCULA_QTDE_PESSOA');

    $procedureCons->addParam(new Param('P_NRLISTA',          Param::PARAM_INPUT, $nrlista,                  Param::PARAM_TYPE_STR));
    $procedureCons->addParam(new Param('P_CDOPERADOR',       Param::PARAM_INPUT, $rows['CDOPERADOR'],       Param::PARAM_TYPE_STR));
    $procedureCons->addParam(new Param('P_CDPRATOINI',       Param::PARAM_INPUT, $cdprodIni,                Param::PARAM_TYPE_STR));
    $procedureCons->addParam(new Param('P_CDPRATOFIM',       Param::PARAM_INPUT, $cdprodFin,                Param::PARAM_TYPE_STR));
    $procedureCons->addParam(new Param('P_IDTIPOEXPORTACAO', Param::PARAM_INPUT, $rows['IDTIPOEXPORTACAO'], Param::PARAM_TYPE_STR));
    $procedureCons->addParam(new Param('P_IDTIPORECEITA',    Param::PARAM_INPUT, $tipoReceita,              Param::PARAM_TYPE_STR));
    $procedureCons->addParam(new Param('P_VRQTDEPESSOA',     Param::PARAM_INPUT, $vrqtdepessoa,             Param::PARAM_TYPE_STR));
    $procedureCons->addParam(new Param('P_CDFILCENTPME',     Param::PARAM_INPUT, $rows['CDFILCENTPME'],     Param::PARAM_TYPE_STR));
    $procedureCons->addParam(new Param('P_NRLISTATP',        Param::PARAM_INPUT, $nrlistatp,                Param::PARAM_TYPE_STR));
 
    $procedureCons->execute();

    return $procedureCons;
  }
  
  public function getServicos($rows){
    $dataSourceName = 'servicoAgrupGrupoUnidadeInd';
    
    if (empty($rows['UNIDADE'])) $cdfilial = 'T';
    else {
      $unidadeRow = [];
      $cdfilial = join("_", $rows['UNIDADE']);
    }
    
    $conditions = array(
        array(
            'columnName' => 'CDFILIAL',
            'operator' => '=',
            'value' => $cdfilial
        ),
        array(
            'columnName' => 'CDGRUPSERV',
            'operator' => '=',
            'value' => 'T'
        ),
        array(
            'columnName' => 'CDGRUPFILI',
            'operator' => '=',
            'value' => 'T'
        ),
        array(
            'columnName' => 'IDTIPOSERV',
            'operator' => '=',
            'value' => $rows['IDTIPOSERV']
        )
    );
    
    $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
    return $result;
  }
  
  public function getTipoCard($rows){
    $nrorg = $this->utilities->getNrOrg();
    $dataSourceName = 'tpCardapioPorCentralAtivo';
    
    $conditions = array(       
        array(
            'columnName' => 'IDTPCARDATIV',
            'operator' => '=',
            'value' => 'S'
        ),
        array(
            'columnName' => 'CDFILCENTPME',
            'operator' => '=',
            'value' =>  $rows['CDFILCENTPME']
        ),
        array(
            'columnName' => 'NRPASTATCARD',
            'operator' => '=',
            'value' => null
        ),
        array(
            'columnName' => 'NRORG',
            'operator' => '=',
            'value' => $nrorg
        )
    );
    
    $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
    return $result;
  }
  
  public function getAgregadaCentralPAE($rows){
    $nrorg = $this->utilities->getNrOrg();
    $dataSourceName = 'agregadaPorCentral';
    
    $conditions = array(
        array(
            'columnName' => 'CDFILCENTPME',
            'operator' => '=',
            'value' => $rows['CDFILCENTPME']
        )
    );

    $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
    return $result;
  }
}
