<?php

/**
 * Estruturah
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     alessandrobartels - 26/04/2011 10:18:30 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Estruturah extends DaoEstruturah
{


    /**
     * Retorna historico atual.
     *
     * @param integer    $nrEstrutura    Numero da estrutura.
     * @param TkDateTime $mesCompetencia Mes de competencia.
     *
     * @return EstruturahEntity
     */
    public static function retornaEstruturaHistorico($nrOrg, $nrEstrutura, TkDateTime $mesCompetencia){
        try{

            // Query CRIADA SUBSTITUINDO O CÓDIGO COMENTADO - motivo manter o padrão,   BORBA 19/03/2013
            $db = \Setforms2\Runtime\Connection::getInstance();
            $sql = "SELECT *
                    FROM ESTRUTURAH EXT
                    WHERE DTMESCOMPETENC IN (
                        SELECT MAX (SUB.DTMESCOMPETENC) DTMESCOMPETENC
                        FROM ESTRUTURAH SUB
                        WHERE SUB.DTMESCOMPETENC <= '$mesCompetencia'
                        AND SUB.NRORG = EXT.NRORG
                        AND SUB.NRESTRUTURAM = EXT.NRESTRUTURAM
                        )
                    AND EXT.NRESTRUTURAM = $nrEstrutura
                    AND EXT.NRORG = $nrOrg";
            $resultado = $db->fetchAll($sql);

            return self::createObjectsFromArray($resultado);
        } catch (Exception $e) {
            throw $e;
        }
        /* $db = TkDb::singleton(); */
        //ANTIGO
        /*$resultados = self::getObjectsByWhere(
            'NRORG = ?
            AND NRESTRUTURAM = ?
            AND DTMESCOMPETENC <= ?',
            array(
                $nrOrg, $nrEstrutura, $mesCompetencia,
            ),
            'DTMESCOMPETENC'
        );
        return $resultados;*/

    }


    public static function retornaEstruturaHistoricoPorInscricao($nrOrg, $nrInscricao, $idTipoInscricao){


        switch($idTipoInscricao){
            case EstruturahEntity::IDTIPOINSCRICAO_CNPJ:
                $where = 'NRORG = ? AND CDCNPJESTRUT = ?';
                break;
            case EstruturahEntity::IDTIPOINSCRICAO_CEI:
                $where = 'NRORG = ? AND CDCEIESTRUT = ?';
                break;
            case EstruturahEntity::IDTIPOINSCRICAO_CPF:
                $where = 'NRORG = ? AND CDCPFESTRUTURA = ?';
                break;
        }

        $resultado = self::getObjectByWhere(
           $where, array($nrOrg, $nrInscricao)
        );

        return $resultado;
    }

    public static function returnWorkStructureFromOrgAndCompetenceDate($nrOrg, $dtCompetence){

        $result = self :: getObjectByWhere(
            'NRORG = ?
            AND DTMESCOMPETENC <= ?',
            array(
                $nrOrg, $dtCompetence,
            ),
                'NRESTRUTURAM'
        );

        return $result;
    }

}